import { join } from 'path';
const INDEX_HTML_PATH = '/index.html';
const START_HTML_PATH = '/start.html';
export const preserveIndexHtml = async (browserOutputPath, document, readFileAsync, writeFileAsync) => {
    await writeFileAsync(join(browserOutputPath, 'start.html'), document);
    try {
        const ngswPath = join(browserOutputPath, 'ngsw.json');
        const ngswObject = JSON.parse(await readFileAsync(ngswPath, 'utf8'));
        if (ngswObject.index === INDEX_HTML_PATH) {
            ngswObject.index = START_HTML_PATH;
        }
        if (ngswObject.assetGroups !== undefined) {
            ngswObject.assetGroups.forEach((assetGroup) => {
                assetGroup.urls = assetGroup.urls.map((url) => {
                    if (url === INDEX_HTML_PATH) {
                        return START_HTML_PATH;
                    }
                    return url;
                });
            });
        }
        if (ngswObject.hashTable !== undefined && ngswObject.hashTable[INDEX_HTML_PATH] !== undefined) {
            ngswObject.hashTable[START_HTML_PATH] = ngswObject.hashTable[INDEX_HTML_PATH];
            ngswObject.hashTable[INDEX_HTML_PATH] = undefined;
        }
        await writeFileAsync(ngswPath, JSON.stringify(ngswObject));
        return true;
    }
    catch (err) {
        if (err.code !== 'ENOENT') {
            throw err;
        }
        return false;
    }
};
//# sourceMappingURL=preserve-index-html.js.map