import { isModule } from '../guards/module.js';
export const bindRenderFunction = async (main, renderUtils) => {
  const {
    default: bootstrapOrModule
  } = await import(main);
  const {
    renderApplication,
    renderModule
  } = await import(renderUtils);
  if (isModule(bootstrapOrModule)) {
    return ({
      document,
      platformProviders,
      url
    }) => renderModule(bootstrapOrModule, {
      document,
      extraProviders: platformProviders,
      url
    });
  }
  return renderApplication.bind(null, bootstrapOrModule);
};